--
-- SpeedJoystick
--
-- written by fruktor, visit: www.eifok-team.de
--

SpeedJoystick = {};

SpeedJoystick.modDir = g_currentModDirectory;

function SpeedJoystick.prerequisitesPresent(specializations)
    return true; 
end;

function SpeedJoystick:load(xmlFile)
	self.sj = {};
	self.sj.node = Utils.indexToObject( self.components, getXMLString(xmlFile, "vehicle.speedJoystick#node") );
	self.sj.style = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.speedJoystick#style"), 1);
	self.sj.rotF = getXMLFloat(xmlFile, "vehicle.speedJoystick#rotFront");
	self.sj.rotB = getXMLFloat(xmlFile, "vehicle.speedJoystick#rotBack");
	if self.sj.rotF ~= nil and self.sj.rotB ~= nil then
		self.sj.rotF = math.rad(self.sj.rotF);
		self.sj.rotB = math.rad(self.sj.rotB);
	end;
	self.sj.posF = getXMLFloat(xmlFile, "vehicle.speedJoystick#posFront");
	self.sj.posB = getXMLFloat(xmlFile, "vehicle.speedJoystick#posBack");
	self.sj.posT = 0;
	self.sj.posC = 0;
	self.sj.rotT = 0;
	self.sj.rotC = 0;
	
end;

function SpeedJoystick:delete()

end;

function SpeedJoystick:readStream(streamId, connection)
end;

function SpeedJoystick:writeStream(streamId, connection)
end;

function SpeedJoystick:mouseEvent(posX, posY, isDown, isUp, button)
end;

function SpeedJoystick:keyEvent(unicode, sym, modifier, isDown)
end;

function SpeedJoystick:update(dt)

	if self:getIsActive() then
		if self.isClient then
			
			local axisForward = 0;
			axisForward = InputBinding.getDigitalInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
			if InputBinding.isAxisZero(axisForward) then
				axisForward = InputBinding.getAnalogInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE)
			end;
			
			if axisForward < 0 then
				
				if self.sj.style == 1 then
					self.sj.rotT = -self.sj.rotF*axisForward;
				else
					self.sj.posT = -self.sj.posF*axisForward;
				end;
			elseif axisForward > 0 then
				
				if self.sj.style == 1 then
					self.sj.rotT = self.sj.rotB*axisForward;
				else
					self.sj.posT = self.sj.posB*axisForward;
				end;
			else

				if self.sj.style == 1 then
					self.sj.rotT = 0;
				else
					self.sj.posT = 0;
				end
			end
			
			if self.ESLimiter ~= nil and self.lastLevel ~= 0 and self:getIsActiveForInput(false) and not self:hasInputConflictWithSelection() then
				local percentage = self.ESLimiter.percentage;
				if InputBinding.isPressed(InputBinding.ESLimiter_PLUS) and percentage[self.lastLevel] < 100 then					
					if self.sj.style == 1 then
						self.sj.rotT = self.sj.rotF/2;
					else
						self.sj.posT = self.sj.posF/2;
					end;
				elseif InputBinding.isPressed(InputBinding.ESLimiter_MINUS) and percentage[self.lastLevel] > 10 then
					if self.sj.style == 1 then
						self.sj.rotT = self.sj.rotB/2;
					else
						self.sj.posT = self.sj.posB/2;
					end;
				end;
			end;			
			
			if self.sj.style == 1 then
				if self.sj.rotC < self.sj.rotT then
					self.sj.rotC = self.sj.rotC + dt/1000;
					if self.sj.rotC > self.sj.rotT then
						self.sj.rotC = self.sj.rotT;
					end;
				elseif self.sj.rotC > self.sj.rotT then
					self.sj.rotC = self.sj.rotC - dt/1000;
					if self.sj.rotC < self.sj.rotT then
						self.sj.rotC = self.sj.rotT;
					end;
				end;
				setRotation( self.sj.node, 0, 0, self.sj.posC );
			else
				if self.sj.posC < self.sj.posT then
					self.sj.posC = self.sj.posC + dt/20000;
					if self.sj.posC > self.sj.posT then
						self.sj.posC = self.sj.posT;
					end;
				elseif self.sj.posC > self.sj.posT then
					self.sj.posC = self.sj.posC - dt/20000;
					if self.sj.posC < self.sj.posT then
						self.sj.posC = self.sj.posT;
					end;
				end;
				setTranslation( self.sj.node, 0, 0,self.sj.posC );
			end;
		end;
	end;

	

	if self.motor.speedLevel ~= 0 then
	end;
	
end;

function SpeedJoystick:updateTick(dt)

end;

function SpeedJoystick:onLeave()
end;

function SpeedJoystick:draw()
end;